=== debian/changelog ===
vxl (1.17.0-8) unstable; urgency=high

  * Remove B-D: libtiff5-dev, as it makes vxl FTBFS. Closes: #721493

 -- Mathieu Malaterre <malat@debian.org>  Fri, 29 Nov 2013 08:41:19 +0100

vxl (1.17.0-7) unstable; urgency=high

  * Hide symptoms from --as-needed on IA64. Closes: #728574
  * Update d/copyright. Closes: #723126

 -- Mathieu Malaterre <malat@debian.org>  Thu, 28 Nov 2013 14:52:51 +0100

vxl (1.17.0-6) unstable; urgency=medium

  * Remove B-D: libtiff5-dev, as it makes vxl FTBFS. Closes: #721493
  * wrap and sort d/control
  * Remove -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo from d/rules

 -- Mathieu Malaterre <malat@debian.org>  Mon, 02 Sep 2013 09:21:29 +0200

vxl (1.17.0-5) unstable; urgency=low

  * Use libcoin80-dev for transition
  * Fix compilation of opencl module on kFreeBSD

 -- Mathieu Malaterre <malat@debian.org>  Thu, 30 May 2013 10:44:57 +0200

vxl (1.17.0-4) unstable; urgency=low

  * Fix builds on arm* by removing duplicate symbols
  * Re-activate testing. Closes: #671601
  * Build OpenCL modules. Closes: #697784
  * Run two cmake configure steps. Closes: #708131
  * make package multiarch

 -- Mathieu Malaterre <malat@debian.org>  Tue, 28 May 2013 15:08:55 +0200

vxl (1.17.0-3) unstable; urgency=low

  * Import old patch and avoid name clash. Closes: #708666, #708668
  * Re-import old sse2.patch, fix compilation.
  * Re-import old ffmpeg/C99 patch. Closes: #708740

 -- Mathieu Malaterre <malat@debian.org>  Sun, 19 May 2013 16:11:07 +0200

vxl (1.17.0-2) unstable; urgency=low

  * Upload to sid.
  * Fix comp with libav. Closes: #693543
    + debian/patches/libav_trunk.patch
  * Fix compilation issues. Closes: #708358
    + debian/patches/bug708358.patch
  * Fix compilation. Closes: #707472
    + debian/patches/bug707472.patch

 -- Mathieu Malaterre <malat@debian.org>  Wed, 15 May 2013 16:53:56 +0200

vxl (1.17.0-1) experimental; urgency=low

  * New upstream
  * Use shapelib package
  * Remove deprecated DMUA flag
  * Bump Std-Vers to 3.9.4, no changes needed
  * Re-add avifile binding (see #647787)

 -- Mathieu Malaterre <malat@debian.org>  Fri, 28 Dec 2012 22:31:32 +0100
