=== debian/control ===
Source: vxl
Homepage: http://vxl.sf.net
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>,
           Andreas Tille <tille@debian.org>
Build-Depends: cmake (>= 2.4.5),
               debhelper (>= 9),
               freeglut3-dev,
               libavcodec-dev,
               libavformat-dev,
               libavifile-0.7-dev,
               libbz2-dev,
               libcoin80-dev,
               libdc1394-22-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
               libdcmtk2-dev,
               libexpat-dev,
               libgeotiff-dev, libtiff-dev,
               libglu-dev,
               libjpeg-dev,
               libmpeg2-4-dev,
               libpng-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               libshp-dev,
               libswscale-dev,
               libxerces-c-dev,
               ocl-icd-opencl-dev,
               opencl-headers,
               python-dev (>= 2.6.6-3~),
               zlib1g-dev
Standards-Version: 3.9.4
X-Python-Version: 2.7
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/vxl/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/vxl/trunk/

Package: libvxl1.17
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ Libraries for Computer Vision Research
 VXL (the Vision-something-Libraries) is a collection of C++ libraries
 designed for computer vision research and implementation. It was created
 from TargetJr and the IUE with the aim of making a light, fast and
 consistent system. VXL is written in ANSI/ISO C++ and is designed to be
 portable over many platforms.

Package: libvxl1-dev
Section: libdevel
Architecture: any
Depends: libvxl1.17 (= ${binary:Version}), ${misc:Depends}
Provides: libvxl-dev
Description: C++ Libraries for Computer Vision Research
 VXL (the Vision-something-Libraries) is a collection of C++ libraries
 designed for computer vision research and implementation. It was created
 from TargetJr and the IUE with the aim of making a light, fast and
 consistent system. VXL is written in ANSI/ISO C++ and is designed to be
 portable over many platforms.
 .
 This package contains the development files needed to build your own
 VXL applications.
