=== debian/watch ===
version=3
http://sf.net/vxl/vxl-([\d\.]+)\.tar.gz
